#ifndef XML_INCLUDED
#define XML_INCLUDED

#include "table.h"

class Xml : public Table
{
protected:

    UnbufferedTextFile tab_buffer;

    void PrintTable(Array<int> &, int, int, int);
    void PrintSymbol(int, const char *);

    Option *option;
    Grammar *grammar;

public:

    Xml(Control *control_, Pda *pda_) : Table(control_, pda_),
                                        tab_buffer(&systab)
    {
        option = control_ -> option;
        grammar = control_ -> grammar;
    }

    virtual ~Xml() {}

    virtual void PrintTables(void);
};

#endif /* XML_INCLUDED */
