%options ast_directory=./ExprAst
%options automatic_ast=toplevel
%options var=nt
%options fp=ExprParser
%options package=expr3
%options template=dtParserTemplateD.g
%options import_terminals=ExprLexer.g

$Define
    $BeginAstAction
    /.
    	void initialize()
        {./

    $EndAstAction 
    /.  }
    ./

$End

$Terminals
    PLUS ::= +
    MULTIPLY ::= *
    LPAREN ::= (
    RPAREN ::= )
    
$end

$Ast
    /.
        int value;
        public int getValue() { return value; }
        protected void setValue(int value) { this.value = value; }
    ./
$End

$Rules
    E ::= E + T
    /.$BeginAstAction
            setValue(((Ast) getE()).getValue() + ((Ast) getT()).getValue());
      $EndAstAction
    ./
        | T
    T ::= T * F
    /.$BeginAstAction
            setValue(((Ast) getT()).getValue() * ((Ast) getF()).getValue());
      $EndAstAction
    ./
        | F
    F ::= IntegerLiteral$Number
    /.$BeginAstAction
            setValue(new Integer(getNumber().toString()).intValue());
      $EndAstAction
    ./
    F$ParenExpr ::= ( E )
    /.$BeginAstAction
            setValue(((Ast) getE()).getValue());
      $EndAstAction
    ./
$End
