// XMOS
package org.eclipse.cdt.debug.internal.ui.actions;

import org.eclipse.cdt.debug.core.CDebugCorePlugin;
import org.eclipse.debug.ui.IDebugView;
import org.eclipse.jface.action.IAction;
import org.eclipse.ui.IViewActionDelegate;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.actions.ActionDelegate;

public class GlobalsModeActionDelegate extends ActionDelegate implements IViewActionDelegate {
    private IViewPart m_view;
    
    public void run( IAction action ) {
        CDebugCorePlugin.getDefault().setGlobalsVisible(action.isChecked());
        if (m_view instanceof IDebugView) {
            ((IDebugView)m_view).getViewer().refresh();
        }
    }

    public void init(IAction action) {
        CDebugCorePlugin.getDefault().setGlobalsVisible(action.isChecked());
    }
    
    public void init(IViewPart view) {
        m_view = view;
    }    
}
